BM53 缺失的第一个正整数,哈希表,原地哈希(扩展思路)

BM53 缺失的第一个正整数

  • 1 描述
  • 方法一:哈希表
  • 方法二:原地哈希(扩展思路)

1 描述

给定一个未排序的整数数组nums,请你找出其中没有出现的最小的正整数

进阶: 空间复杂度 O(1)O(1),时间复杂度 O(n)O(n)

数据范围:

-231<=numsi<=231-1

0<=len(nums)<=5*105

示例1

输入:1,0,2

返回值:3

示例2

输入:-2,3,4,1,5

返回值:2

示例3

输入:4,5,6,8,9

返回值:1

方法一:哈希表

思路:

nnn个长度的数组,没有重复,则如果数组填满了1~n,那么缺失n+1,如果数组填不满1~n,那么缺失的就是1~n中的数字。对于这种快速查询某个元素是否出现过的问题,还是可以使用哈希表快速判断某个数字是否出现过。

具体做法:

step 1:构建一个哈希表,用于记录数组中出现的数字。

step 2:从1开始,遍历到n,查询哈希表中是否有这个数字,如果没有,说明它就是数组缺失的第一个正整数,即找到。

step 3:如果遍历到最后都在哈希表中出现过了,那缺失的就是n+1.

复杂度分析:

时间复杂度:O(n),第一次遍历数组,为O(n),第二次最坏从1遍历到n,为O(n)

空间复杂度:O(n),哈希表记录nnn个不重复的元素,长度为nnn

cpp 复制代码
int minNumberDisappeared(vector<int>& nums) {
        // write code here
        int res = 1;
        unordered_map<int, int> hash;
        //哈希表记录数组中出现的每个数字
        for(auto num : nums)
            hash[num]++;
         //从1开始找到哈希表中第一个没有出现的正整数
        while(hash.find(res) != hash.end())
            res++; 
        return res;

方法二:原地哈希(扩展思路)

思路:

前面提到了数组要么缺失1~n中的某个数字,要么缺失n+1,而数组正好有下标0~n−1可以对应数字1~n,因此只要数字1~n中某个数字出现,我们就可以将对应下标的值做一个标记,最后没有被标记的下标就是缺失的值。

具体做法:

step 1:我们可以先遍历数组将所有的负数都修改成n+1。

step 2:然后再遍历数组,每当遇到一个元素绝对值不超过n时,则表示这个元素是1~n中出现的元素,我们可以将这个数值对应的下标里的元素改成负数,相当于每个出现过的正整数,我们把与它值相等的下标都指向一个负数,这就是类似哈希表的实现原理的操作。

step 3:最后遍历数组的时候碰到的第一个非负数,它的下标就是没有出现的第一个正整数,因为它在之前的过程中没有被修改,说明它这个下标对应的正整数没有出现过。

力扣图解

复杂度分析:

时间复杂度:O(n),多次遍历数组,都是单层循环

空间复杂度:O(1),原地哈希,以索引为指向,没有额外空间

cpp 复制代码
int minNumberDisappeared(vector<int>& nums) {
        // write code here
       int n = nums.size();
        
        //负数全部记为n+1
       for(auto &num : nums){ //若用auto,这里要取地址,不然会有部分测试不通过
           if(num <=0)
               num = n+1;
       }
        
        //对于1-n范围内的数字,将出现的数字-1,作为下标,并将该下标下的值替换为,负的[数字-1];;;
        //即 nums[num-1] = -abs(nums[num - 1]);
       for(int i=0;i<n;i++){
           int num = abs(nums[i]); //如果有相同的数字,那么同一下标下的值会被反复的,取负号,,导致正负不定,,故每次确保他是正数
           if(num <= n){
               nums[num-1] = -1*abs(nums[num - 1]);//这里,取负数,最好 *-1实现
           }
       } 
       
        //找到第一个元素不为负数的下标,就是缺失的第一个正整数
        for(int i=0;i<n;i++){
            if(nums[i] > 0) 
                return i+1;
        }
         return n+1; //如果1~n之间没有缺失的,就是n+1 
    }
相关推荐
姜鱼问生12 分钟前
Nginx gzip 压缩:一个配置让页面加载快 3 倍
后端·算法·架构
不会就选b17 分钟前
算法日常・每日刷题--<动态规划>23
算法·动态规划
GreatSQL社区38 分钟前
主从复制SQL线程中断——字符集砸出的坑
java·数据库·算法
Tisfy2 小时前
LeetCode 2333.最小差值平方和:排序 + 数学计算(不用二分)
数学·算法·leetcode·题解·贪心·排序
aqiu1111112 小时前
【C++算法打怪专栏】LeetCode 217. 存在重复元素(解法总结)
c++·算法·leetcode
yi0113 小时前
DAY28: LeetCode 111. 二叉树的最小深度
人工智能·笔记·python·算法·leetcode·二叉树·递归
wuyk5553 小时前
27.LeetCode 2265. 统计值等于子树平均值的节点数 —— 后序遍历实战
stm32·单片机·嵌入式硬件·算法
xiangyun613 小时前
C++ list 模拟实现(二):const迭代器与反向迭代器,模板的黑魔法
开发语言·数据库·c++·算法·stl·list
xxwl5854 小时前
三、区域赛算法模版第三章---字符串相关算法
笔记·学习·算法
信奥卷王4 小时前
[GESP202509 六级] 划分字符串(含视频)
数据结构·算法